- Main Page
- Related Pages
- Modules
- Files

Functions
Integer functions
GLM Core

## Functions
template<typename T , template< typename > class genIUType>
genIUType< T >::signed_type | bitCount (genIUType< T > const &Value)
template<typename genIUType >
genIUType | bitfieldExtract (genIUType const &Value, int const &Offset, int const &Bits)
template<typename genIUType >
genIUType | bitfieldInsert (genIUType const &Base, genIUType const &Insert, int const &Offset, int const &Bits)
template<typename genIUType >
genIUType | bitfieldReverse (genIUType const &Value)
template<typename T , template< typename > class genIUType>
genIUType< T >::signed_type | findLSB (genIUType< T > const &Value)
template<typename T , template< typename > class genIUType>
genIUType< T >::signed_type | findMSB (genIUType< T > const &Value)
template<typename genIType >
void | imulExtended (genIType const &x, genIType const &y, genIType &msb, genIType &lsb)
template<typename genUType >
genUType | uaddCarry (genUType const &x, genUType const &y, genUType &carry)
template<typename genUType >
void | umulExtended (genUType const &x, genUType const &y, genUType &msb, genUType &lsb)
template<typename genUType >
genUType | usubBorrow (genUType const &x, genUType const &y, genUType &borrow)

## Detailed Description

These all operate component-wise.

The description is per component. The notation [a, b] means the set of bits from bit-number a through bit-number b, inclusive. The lowest-order bit is bit 0.

## Function Documentation

genIUType<T>::signed_type glm::bitCount | ( | genIUType< T > const & | Value | ) |

Returns the number of bits set to 1 in the binary representation of value.

Template Parameters

  genIUType | Signed or unsigned integer scalar or vector types.

See Also
  GLSL bitCount man page
  GLSL 4.20.8 specification, section 8.8 Integer Functions

Todo:
  Clarify the declaration to specify that scalars are suported.

genIUType glm::bitfieldExtract | ( | genIUType const & | Value,
|  | int const & | Offset,
|  | int const & | Bits
| ) |  |

Extracts bits [offset, offset + bits - 1] from value, returning them in the least significant bits of the result.

For unsigned data types, the most significant bits of the result will be set to zero. For signed data types, the most significant bits will be set to the value of bit offset + base – 1.

If bits is zero, the result will be zero. The result will be undefined if offset or bits is negative, or if the sum of offset and bits is greater than the number of bits used to store the operand.

Template Parameters

  genIUType | Signed or unsigned integer scalar or vector types.

See Also
  GLSL bitfieldExtract man page
  GLSL 4.20.8 specification, section 8.8 Integer Functions

genIUType glm::bitfieldInsert | ( | genIUType const & | Base,
|  | genIUType const & | Insert,
|  | int const & | Offset,
|  | int const & | Bits
| ) |  |

Returns the insertion the bits least-significant bits of insert into base.

The result will have bits [offset, offset + bits - 1] taken from bits [0, bits – 1] of insert, and all other bits taken directly from the corresponding bits of base. If bits is zero, the result will simply be base. The result will be undefined if offset or bits is negative, or if the sum of offset and bits is greater than the number of bits used to store the operand.

Template Parameters

  genIUType | Signed or unsigned integer scalar or vector types.

See Also
  GLSL bitfieldInsert man page
  GLSL 4.20.8 specification, section 8.8 Integer Functions

genIUType glm::bitfieldReverse | ( | genIUType const & | Value | ) |

Returns the reversal of the bits of value.

The bit numbered n of the result will be taken from bit (bits - 1) - n of value, where bits is the total number of bits used to represent value.

Template Parameters

  genIUType | Signed or unsigned integer scalar or vector types.

See Also
  GLSL bitfieldReverse man page
  GLSL 4.20.8 specification, section 8.8 Integer Functions

genIUType<T>::signed_type glm::findLSB | ( | genIUType< T > const & | Value | ) |

Returns the bit number of the least significant bit set to 1 in the binary representation of value.

If value is zero, -1 will be returned.

Template Parameters

  genIUType | Signed or unsigned integer scalar or vector types.

See Also
  GLSL findLSB man page
  GLSL 4.20.8 specification, section 8.8 Integer Functions

Todo:
  Clarify the declaration to specify that scalars are suported.

genIUType<T>::signed_type glm::findMSB | ( | genIUType< T > const & | Value | ) |

Returns the bit number of the most significant bit in the binary representation of value.

For positive integers, the result will be the bit number of the most significant bit set to 1. For negative integers, the result will be the bit number of the most significant bit set to 0. For a value of zero or negative one, -1 will be returned.

Template Parameters

  genIUType | Signed or unsigned integer scalar or vector types.

See Also
  GLSL findMSB man page
  GLSL 4.20.8 specification, section 8.8 Integer Functions

Todo:
  Clarify the declaration to specify that scalars are suported.

void glm::imulExtended | ( | genIType const & | x,
|  | genIType const & | y,
|  | genIType & | msb,
|  | genIType & | lsb
| ) |  |

Multiplies 32-bit integers x and y, producing a 64-bit result.

The 32 least-significant bits are returned in lsb. The 32 most-significant bits are returned in msb.

Template Parameters

  genIType | Signed integer scalar or vector types.

See Also
  GLSL imulExtended man page
  GLSL 4.20.8 specification, section 8.8 Integer Functions

genUType glm::uaddCarry | ( | genUType const & | x,
|  | genUType const & | y,
|  | genUType & | carry
| ) |  |

Adds 32-bit unsigned integer x and y, returning the sum modulo pow(2, 32).

The value carry is set to 0 if the sum was less than pow(2, 32), or to 1 otherwise.

Template Parameters

  genUType | Unsigned integer scalar or vector types.

See Also
  GLSL uaddCarry man page
  GLSL 4.20.8 specification, section 8.8 Integer Functions

void glm::umulExtended | ( | genUType const & | x,
|  | genUType const & | y,
|  | genUType & | msb,
|  | genUType & | lsb
| ) |  |

Multiplies 32-bit integers x and y, producing a 64-bit result.

The 32 least-significant bits are returned in lsb. The 32 most-significant bits are returned in msb.

Template Parameters

  genUType | Unsigned integer scalar or vector types.

See Also
  GLSL umulExtended man page
  GLSL 4.20.8 specification, section 8.8 Integer Functions

genUType glm::usubBorrow | ( | genUType const & | x,
|  | genUType const & | y,
|  | genUType & | borrow
| ) |  |

Subtracts the 32-bit unsigned integer y from x, returning the difference if non-negative, or pow(2, 32) plus the difference otherwise.

The value borrow is set to 0 if x >= y, or to 1 otherwise.

Template Parameters

  genUType | Unsigned integer scalar or vector types.

See Also
  GLSL usubBorrow man page
  GLSL 4.20.8 specification, section 8.8 Integer Functions